pulseaudio crashed with SIGABRT in device_start_waiting_for_profiles() from pa_bluetooth_transport_set_state() from endpoint_set_configuration() from endpoint_handler() from _dbus_object_tree_dispatch_and_unlock()

Bug #1690028 reported by errors.ubuntu.com bug bridge on 2017-05-11
12
This bug affects 1 person
Affects Status Importance Assigned to Milestone
PulseAudio
Fix Released
Medium
pulseaudio (Ubuntu)
High
Daniel van Vugt
Xenial
Undecided
Unassigned

Bug Description

[Impact]
pulseaudio daemon crashes, interrupting sound output/input.

[Test Case]
Theoretical test case (crash does not happen for all users):
1. Get a Bluetooth audio device capable of multiple profiles (e.g. high
   fidelity A2DP and the lower quality headset profiles).
2. Pair it with your machine and select the device in sound settings.
3. Turn the Bluetooth audio device off and on again, making sure it is
   set to active if not automatically so.
4. Select the device in sound settings.
5. Check that that pulseaudio process is still running, with a start
   time older than when you began this test case.

[Regression Potential]
Low. This SRU affects the pulseaudio daemon only so the worst case would
be loss of sound output/input. The same patches have been released to
17.10 for a month already and zero regressions of the crashes have
occurred worldwide since then.

[Other Info]
Debdiff patch is attached to the most prolific bug 1539209.

[Original Description]

The Ubuntu Error Tracker has been receiving reports about a problem regarding pulseaudio. This problem was most recently seen with package version 1:10.0-1ubuntu2, the problem page at https://errors.ubuntu.com/problem/5a76b9eca937daf6dc05fd32a35fa50e58ccf8f5 contains more details, including versions of packages affected, stacktrace or traceback, and individual crash reports.
If you do not have access to the Ubuntu Error Tracker you can request it at http://forms.canonical.com/reports/.

Changed in pulseaudio (Ubuntu):
importance: Undecided → High
status: New → Confirmed
Daniel van Vugt (vanvugt) wrote :

Sounds similar to bug 1672171.

summary: - /usr/bin/pulseaudio:6:device_start_waiting_for_profiles:pa_bluetooth_transport_set_state:endpoint_set_configuration:endpoint_handler:_dbus_object_tree_dispatch_and_unlock
+ pulseaudio crashed with SIGABRT in device_start_waiting_for_profiles()
+ from pa_bluetooth_transport_set_state() from
+ endpoint_set_configuration() from endpoint_handler() from
+ _dbus_object_tree_dispatch_and_unlock()
tags: added: artful
tags: added: regression-proposed
Daniel van Vugt (vanvugt) wrote :

The crash is this assert:

static void device_start_waiting_for_profiles(pa_bluetooth_device *device) {
    pa_assert(!device->wait_for_profiles_timer);
    device->wait_for_profiles_timer = pa_core_rttime_new(device->discovery->core,
                                                         pa_rtclock_now() + WAIT_FOR_PROFILES_TIMEOUT_USEC,
                                                         wait_for_profiles_cb, device);
}

Daniel van Vugt (vanvugt) wrote :

An upstream fix already exists (coming soon in PulseAudio 11):

https://github.com/pulseaudio/pulseaudio/commit/cb78d6f57c00f3694dae9110f7a7d6f80e3344ac

So the fix does not yet exist in _any_ Ubuntu release.

Changed in pulseaudio:
importance: Unknown → Medium
status: Unknown → Fix Released
Daniel van Vugt (vanvugt) wrote :

OK, that's slightly wrong. Upstream it's Fix Committed, not Fix Released.

Changed in pulseaudio (Ubuntu):
assignee: nobody → Daniel van Vugt (vanvugt)
status: Confirmed → In Progress
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package pulseaudio - 1:10.0-2ubuntu1

---------------
pulseaudio (1:10.0-2ubuntu1) artful; urgency=medium

  * Cherrypick fixes for common crashes from upstream:
    - cb78d6f5: SIGABRT in device_start_waiting_for_profiles (LP: #1690028,
      LP: #1672171)
    - d985276c: SIGABRT in pa_alsa_path_set_volume (LP: #1539209, LP: #1562817)
  * Enable modules that needn't be disabled:
    - module-role-cork: Now enabled per upstream defaults (LP: #1701688)
    - module-switch-on-connect: Enabled for seamless hotplugging (LP: #1702794)
  * Don't try to load sounds that don't exist in Kubuntu (LP: #1703334)
  * Merge latest debian changes (see below).

 -- Daniel van Vugt <email address hidden> Tue, 11 Jul 2017 16:57:16 +0800

Changed in pulseaudio (Ubuntu):
status: Fix Committed → Fix Released
description: updated

Hello errors.ubuntu.com, or anyone else affected,

Accepted pulseaudio into xenial-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/pulseaudio/1:8.0-0ubuntu3.4 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-xenial to verification-done-xenial. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-xenial. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in pulseaudio (Ubuntu Xenial):
status: New → Fix Committed
tags: added: verification-needed verification-needed-xenial
tags: added: verification-done verification-done-xenial
removed: verification-needed verification-needed-xenial
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package pulseaudio - 1:8.0-0ubuntu3.4

---------------
pulseaudio (1:8.0-0ubuntu3.4) xenial; urgency=medium

  * debian/control: Update Vcs fields to launchpad git.
  * Cherrypick fixes for common crashes from upstream:
    - cb78d6f5: SIGABRT in device_start_waiting_for_profiles (LP: #1690028,
      LP: #1672171)
    - d985276c: SIGABRT in pa_alsa_path_set_volume (LP: #1539209, LP: #1562817)

 -- Daniel van Vugt <email address hidden> Fri, 11 Aug 2017 15:16:57 +0800

Changed in pulseaudio (Ubuntu Xenial):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for pulseaudio has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.